<template>
  <div class="social-article">
    <p class="title-component">
      {{ $t('bounty.social.title') }}
    </p>
    <template v-if="settings">
      <bounty-post
        :settings="settings"
        :posts="bitcoinTalkPosts"
        @created="getAllPosts"
        title="bounty.social.bitcoin_talk_post.title"
        type="bitcoin_talk_post"
        tooltip="bounty.social.bitcoin_talk_post.tooltip"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="steemitPosts"
        @created="getAllPosts"
        title="bounty.social.steemit_post.title"
        type="steemit_post"
        tooltip="bounty.social.steemit_post.tooltip"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="redditPosts"
        @created="getAllPosts"
        title="bounty.social.reddit_post.title"
        type="reddit_post"
        tooltip="bounty.social.reddit_post.tooltip"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="mediumPosts"
        @created="getAllPosts"
        title="bounty.social.medium_post.title"
        type="medium_post"
        tooltip="bounty.social.medium_post.tooltip"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="linkedinPosts"
        @created="getAllPosts"
        title="bounty.social.linkedin_post.title"
        type="linkedin_post"
        regex="regex:^https:\/\/(w{3}.)?linkedin.com\/"
        tooltip="bounty.social.linkedin_post.tooltip"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="facebookPosts"
        @created="getAllPosts"
        title="bounty.social.facebook_post.title"
        type="facebook_post"
        tooltip="bounty.social.facebook_post.tooltip"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="blogPosts"
        @created="getAllPosts"
        title="bounty.social.blog_post.title"
        type="blog_post"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="otherWebsitePosts"
        @created="getAllPosts"
        title="bounty.social.other_website_post.title"
        type="other_website_post"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="otherVideoPosts"
        @created="getAllPosts"
        title="bounty.social.other_video_post.title"
        type="other_video_post"
        >
      </bounty-post><!--
      <bounty-post
        :settings="settings"
        :posts="bugReports"
        @created="getAllPosts"
        title="BUG BOUNTY"
        type="bug_report"
        >
      </bounty-post> -->
    </template>

    <div class="ctu-total">
      <p class="title">{{ $t('common.heta_tokens') }}</p>
      <div class="number">{{ total | formatCurrencyAmount('heta', '0') }}</div>
    </div>
  </div>
</template>

<script>
import _ from 'lodash';

import rf from '../../../common/requests/RequestFactory';
import BountyPost from './BountyArticleComponent/BountyPost';
import bignumber from 'bignumber.js';

export default {
  props: {
    settings: {
      type: Object,
      default:  null,
      required: true,
    }
  },
  components : {
    BountyPost,
  },
  data () {
    return {
      posts: [],
      bitcoinTalkPosts: [],
      steemitPosts: [],
      redditPosts: [],
      mediumPosts: [],
      linkedinPosts: [],
      facebookPosts: [],
      blogPosts: [],
      otherWebsitePosts: [],
      otherVideoPosts: [],
      total: 0,
    };
  },
  methods: {
    hasProperty (property) {
      return _.has(this.posts, property);
    },
    async getAllPosts () {
      const response = await rf.getRequest('BountyRequest').getAllPosts();
      this.calculatorTotal(response.data);
      this.posts = _.groupBy(response.data, 'type');
      this.initData();
    },
    calculatorTotal (data) {
      const approvedData = data.filter(item => item.status === 'approved');
      this.total = approvedData.reduce((sum, item) => {
        return sum.plus(item.heta_tokens);
      }, bignumber('0')).toString();
    },
    initData () {
      this.bitcoinTalkPosts = this.hasProperty('bitcoin_talk_post') ? this.posts.bitcoin_talk_post : [];
      this.steemitPosts = this.hasProperty('steemit_post') ? this.posts.steemit_post : [];
      this.redditPosts = this.hasProperty('reddit_post') ? this.posts.reddit_post : [];
      this.mediumPosts = this.hasProperty('medium_post') ? this.posts.medium_post : [];
      this.linkedinPosts = this.hasProperty('linkedin_post') ? this.posts.linkedin_post : [];
      this.facebookPosts = this.hasProperty('facebook_post') ? this.posts.facebook_post : [];
      this.blogPosts = this.hasProperty('blog_post') ? this.posts.blog_post : [];
      this.otherWebsitePosts = this.hasProperty('other_website_post') ? this.posts.other_website_post : [];
      this.otherVideoPosts = this.hasProperty('other_video_post') ? this.posts.other_video_post : [];
    }
  },
  created () {
    this.getAllPosts()
  },
}
</script>

<style lang="scss">
  @import "../../../../sass/mobile/typoVariables.scss";
  .social-article {
    padding: 30rem 12rem;
  }

  .title-component {
    line-height: 19rem;
    margin-bottom: 30rem;
  }

  .article-item {
    margin-bottom: 27rem;
    .article__title {
      font-size: $small;
      margin-bottom: 10rem;
      font-weight: bold;
    }

    .article__content {
      color: #858585;
      font-size: 12rem;
      margin-bottom: 20rem;
    }

    .article__text {
      display: none;
    }

    .article__input-link {
      font-size: 0;
      margin-bottom: 20rem;
    }

    .article__url {
      vertical-align: middle;
      padding: 6rem 10rem;
      width: calc(100% - 36rem);
      font-size: 13rem;
      color: #222c3c;
      border: 1rem solid #d2d2d2;
      background-color: #fff;
      border-radius: 74rem;

      &::placeholder {
        font-size: 13rem;
      }

      &:focus {
        outline: none;
      }
    }

    .article__btnAdd {
      display: inline-block;
      position: relative;
      vertical-align: middle;
      cursor: pointer;
      margin-left: 4rem;
      width: 32rem;
      height: 32rem;
      background-color: #fff;
      border: 1rem solid $orangeBold;
      border-radius: 74rem;

      &:before,
      &:after {
        content: '';
        display: block;
        height: 2rem;
        width: 10rem;
        background-color: $orangeBold;
        position: absolute;
        left: 50%;
        top: 50%;
        transform: translate(-50% , -50%) rotateZ(90deg);
      }

      &:after {
        transform: translate(-50% , -50%) rotateZ(0);
      }

      &:active {
        background-color: $orangeBold;
        &:before,
        &:after {
          background-color: #fff;
        }
      }
    }

    .article__description {
      font-size: 14rem;
      margin-bottom: 27rem;
    }

    .article__link-group {
      .article__link-item {
        font-size: 0;
        margin-bottom: 10rem;

        .bounty,
        .link,
        .status {
          display: inline-block;
          width: 20%;
          padding: 10rem;
          margin-right: 30rem;
          font-size: 13rem;
          background-color: #ebebeb;
          vertical-align: middle;
          color: #222c3c;
          border-radius: 74rem;
          border: 1rem solid #d8dbe7;
        }

        .link {
          color: #222c3c;
          width: calc(60% - 60rem);
          white-space: nowrap;
          overflow: hidden;
          text-overflow: ellipsis;
          padding: 10rem;
        }
        .bounty {
          text-align: center;
        }
        .status {
          margin-right: 0;
          color: #ffb200;
          padding: 10rem 5rem;
          text-align: center;
          text-transform: capitalize;
          font-weight: bold;
          &.approved {
            color: #09a532;
          }
          &.rejected {
            color: red;
          }
        }
      }
    }
  }

  .error {
    color: red;
    display: inline-block;
    margin-top: 5rem;
    font-size: 13rem;
    display: none;
    transition: all 0.3s ease-in-out;

    &.show {
      display: block;
      padding: 0 !important;
    }
  }

  .ctu-total {
    padding: 0 0 41rem;
    position: relative;

    &:after {
      content: '';
      display: block;
      position: absolute;
      bottom: 0;
      left: 0;
      width: 100%;
      height: 1rem;
      background-color: #ababab;
    }
  }
</style>
